;============================================================
;displays CAnimal info (positions, etc.)
;============================================================
Base_Canimal_display	equ 40h

DisplayDinoInfoMain:
cmp [DisplayDinoInfo_BOOL],0
jz NoDinoDisplay_2
push ebp
mov ebp,esp
sub esp,100
push edi
push esi
push edx
push ecx
push ebx
push eax
mov esi,[BaseData]

;GET BACK BUFFER SURFACE
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

;TITLE
	invoke TextOut,edi,0,Base_Canimal_display,canimal_title,[canimal_title_size]

cmp [CAnimal_Names_INDEX],0
jz NoDinoDisplay_1
cmp [CAnimal_BUF],0
jz NoDinoDisplay_1
cmp [CAnimal_BUF_SIZE],0
jz NoDinoDisplay_1

	mov ecx,[DisplayDino_INDEX]
	mov eax,[CAnimal_Names_INDEX]
	mov edx,[eax+ecx]

	add edx,[CAnimal_Names_BUF]

;INSTANCE NAME
	lea ecx,[edx-1]
	getlengthloop_34234324:
	inc ecx
	cmp BYTE [ecx],0
	jnz getlengthloop_34234324
	sub ecx,edx

	invoke TextOut,edi,10h,Base_Canimal_display+10h,edx,ecx

	mov ecx,[DisplayDino_INDEX]
	mov eax,[CAnimal_BUF]
	mov ebx,[eax+ecx]		;ebx=CAnimal instance

;LOCATION
	sub esp,24
	fld DWORD [ebx+30h]
	fstp QWORD [esp]
	fld DWORD [ebx+34h]
	fstp QWORD [esp+8]
	fld DWORD [ebx+38h]
	fstp QWORD [esp+16]

	lea edx,[ebp-100]
	invoke sprintf,edx,canimal_pos
	add esp,32

	lea edx,[ebp-100]
	lea eax,[edx-1]
	checklengthloop76547457457:
	inc eax
	cmp BYTE [eax],0
	jnz checklengthloop76547457457
	sub eax,edx
	invoke TextOut,edi,10h,Base_Canimal_display+20h,edx,eax

;HEALTH
	sub esp,8
	fld DWORD [ebx+50h]
	fstp QWORD [esp]
	lea edx,[ebp-100]
	invoke sprintf,edx,canimal_health
	add esp,16

	lea edx,[ebp-100]
	lea eax,[edx-1]
	checklengthloop7654sdfs:
	inc eax
	cmp BYTE [eax],0
	jnz checklengthloop7654sdfs
	sub eax,edx
	invoke TextOut,edi,10h,Base_Canimal_display+30h,edx,eax

;MAX HEALTH
	sub esp,8
	fld DWORD [ebx+54h]
	fstp QWORD [esp]
	lea edx,[ebp-100]
	invoke sprintf,edx,canimal_maxhealth
	add esp,16

	lea edx,[ebp-100]
	lea eax,[edx-1]
	checklengthloopsssssdf:
	inc eax
	cmp BYTE [eax],0
	jnz checklengthloopsssssdf
	sub eax,edx
	invoke TextOut,edi,10h,Base_Canimal_display+40h,edx,eax

NoDinoDisplay_1:
;RELEASE SURFACE
	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

pop eax
pop ebx
pop ecx
pop edx
pop esi
pop edi
mov esp,ebp
pop ebp
NoDinoDisplay_2:
ret