;=======================================================
;checks level info before modifying
;=======================================================
Modify_External:
	call VerifyCAnimalBuffers
	     test eax,eax
	     jz No_Modify_934579483543
	call IsLevelSavedGame
	     test eax,eax
	     jnz No_Modify_934579483543
	call ModifyCAnimalInstances
	call SetRandomDinoStartPositions

No_Modify_934579483543:

mov [CounterFirstRun],1
mov [NewLevel_BOOL],1
mov [New_CAnimal_BUF],1 	;create new buffer next time

	mov eax,[CAnimal_BUF_SIZE]
	shr eax,2		;set number of instances string for "CANIMAL" cheat
invoke wsprintfA,canimal_title,canimal_title_base,eax
       add esp,12
       mov [canimal_title_size],eax

ret

;=======================================================
VerifyCAnimalBuffers:	;eax=0 if buffers not OK
;=======================================================
;Note: I don't know the exact size of CAnimal class. This
;routine could be optimized if this size was known.

	mov esi,[BaseData]
	mov esi,[CANIMAL_VTABLE]
	mov edi,[CAnimal_BUF]
	test edi,edi
	    jz BuffersNotOKorEmpty
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	    jz BuffersNotOKorEmpty
	add ebx,edi

TestCAnimalBuffersMainLoop:

invoke IsBadReadPtr,[edi],0E0h
       test eax,eax
       jnz BuffersNotOKorEmpty

invoke IsBadWritePtr,[edi],0E0h
       test eax,eax
       jnz BuffersNotOKorEmpty

       mov eax,[edi]
       cmp [eax],esi		;check if proper VTable is set
       jnz BuffersNotOKorEmpty

add edi,4
cmp edi,ebx
jb TestCAnimalBuffersMainLoop

or al,1
ret

BuffersNotOKorEmpty:
LOCALRELEASE_01 [CAnimal_BUF]
LOCALRELEASE_01 [CAnimal_Names_INDEX]
LOCALRELEASE_01 [CAnimal_Names_BUF]
       and [CAnimal_BUF_SIZE],0
       and [CAnimal_Names_BUF_SIZE],0
xor eax,eax
ret