;============================================================
;MAIN CHEAT CODE LAUNCHER (ONCE PROPERLY ADDRESSED IN EXECUTABLE)
;============================================================
;this first part differs from the EXE's interpretation, but because
;the compiler ordered the functions' indexes, there's no point in
;overcomplicating it

;edi=index into DWORD -> usually tested past a certain value by
;the EXE, but it doesn't go that far. The only exception is the "dinos"
;cheat which would crash the game if used in this matter; however, it
;is modified in the initialization.

FOUNDVALIDCONSOLEINPUT:
	jmp DWORD [4*edi+CHEATJUMPINDEX]	;cede control to proper cheat
;===========================================================
EXITCHEATCODE:
	pop edi        ;if no cheats or if cheat index overruns index
	pop esi
	pop ebp
	or al,1
	pop ebx        ;don't know how the return value should be
	add esp,3Ch    ;exactly set, but if no cheat is found,
	ret	       ;0 is returned so...
;===========================================================
DISPLAYOLDLOCCHEAT:	;set/unset LOC cheat variable
	xor [USE_LOC],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYMAPCONSOLE:	;set/unset MAP cheat variable
	xor [USE_MAP],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYCOUNTER:
	xor [USE_COUNTER],1
jmp EXITCHEATCODE
;===========================================================
RESETCOUNTER:
	invoke GetTickCount
	mov [FirstTimeStamp],eax
jmp EXITCHEATCODE
;===========================================================
BIONICWOMAN_MAIN:
	mov esi,[BaseData]
	mov edx,[GameSpeedVarADDR]
	mov eax,[edx]

	cmp eax,[NormalGameSpeed]
	jz SetSlowSpeed_BIONIC
	mov eax,[NormalGameSpeed]
	mov [edx],eax
jmp EXITCHEATCODE

SetSlowSpeed_BIONIC:
	mov eax,[DefaultSlowSpeed]
	mov [edx],eax
jmp EXITCHEATCODE
;===========================================================
DINOS_MAIN:
	mov esi,[BaseData]
	mov eax,[DINOS_OBJECT]	;also main "AI System" object
	mov edx,[eax]
	xor BYTE [edx+52h],1	;freeze dinos bool
jmp EXITCHEATCODE
;===========================================================
WOO_MAIN:			;for demo EXE only
	mov esi,[BaseData]
	mov eax,[WOO_AMMO_BOOL_ADDR]
	xor BYTE [eax],1
jmp EXITCHEATCODE
;===========================================================
INVUL_EXPERIMENTAL_MAIN:
	mov esi,[BaseData]
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object
	xor BYTE [edx+0DDh],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYDINOINFO:
	xor [DisplayDinoInfo_BOOL],1
jmp EXITCHEATCODE
;===========================================================
CYCLEDINOINFOLEFT:
	mov eax,[DisplayDino_INDEX]
	test eax,eax
	jz Leftwrap1
	sub eax,4
	mov [DisplayDino_INDEX],eax
jmp EXITCHEATCODE

	Leftwrap1:
	mov eax,[CAnimal_BUF_SIZE]
	test eax,eax
	jz EXITCHEATCODE
	sub eax,4
	mov [DisplayDino_INDEX],eax
jmp EXITCHEATCODE
;===========================================================
CYCLEDINOINFORIGHT:
	mov eax,[DisplayDino_INDEX]
	add eax,4
	cmp eax,[CAnimal_BUF_SIZE]
	jnb Rightwrap1
	mov [DisplayDino_INDEX],eax
jmp EXITCHEATCODE

	Rightwrap1:
	and [DisplayDino_INDEX],0
jmp EXITCHEATCODE
;===========================================================
KILLACTIVEDINO:
	mov ecx,[DisplayDino_INDEX]
	mov eax,[CAnimal_BUF]
	mov ebx,[eax+ecx]		;ebx=CAnimal instance
	mov DWORD [ebx+50h],0
jmp EXITCHEATCODE
;===========================================================
SHOWDINOSONMAP:
	xor [ShowDinosOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================
SHOWACTIVEDINOONMAP:
	xor [ShowActiveDinoOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================