;compile using FASM (see "SOURCE_README.txt" in "ATX_DLLSOURCE\" folder
;for last version used)
;this is very poorly coded, but works!

format PE console 4.0
entry START

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

virtual at esi
	freespace_addr	dd	?
	maincode_addr	dd	?
	entrypoint	dd	?
	entry_call	dd	?
	exit_call	dd	?
	exit_addr_1	dd	?
	exit_addr_2	dd	?
	maincode_length dd	?
end virtual

;=================================================================
section '.code' code readable executable
;=================================================================
START:
push ebx
push edi
push ebp
push esi

invoke GetModuleHandle,0
mov [hInstance],eax

invoke GetCommandLine
mov [CommandLine],eax

push esi
push edi
xor edi,edi
lea esi,[eax-1]
;=================================================================
EXENameLoop1:
	inc esi
	mov al,[esi]
	cmp al,20h
		jz EndEXENameLoop
	cmp al,09h
		jz EndEXENameLoop
	cmp al,0Dh
		jz EndParamLoop
	cmp al,0
		jz EndParamLoop
	jmp EXENameLoop1

EndEXENameLoop:
mov edi,SourceFile
inc esi

CopyStringLoop1:
	mov al,[esi]
	cmp al,20h
	jz EndParamLoop
	cmp al,09h
	jz EndParamLoop
	cmp al,0Dh
	jz EndParamLoop
	cmp al,0
	jz EndParamLoop
	mov [edi],al
	inc edi
	inc esi
	jmp CopyStringLoop1

EndParamLoop:
mov eax,edi
pop edi
pop esi

;=================================================================
invoke CopyFile,SourceFile,ATXFileNameStart,FALSE
	test eax,eax
	mov DWORD [esp-4],ErrorText1
	jz MAINERROR

invoke CreateFile,ATXFileNameStart,GENERIC_WRITE,FILE_SHARE_WRITE,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0,0
	test eax,eax
	mov DWORD [esp-4],ErrorText2
	jz MAINERROR
	cmp eax,-1
	jz MAINERROR
	mov [filehandle],eax

invoke GetFileSize,eax
	cmp eax,-1
	mov DWORD [esp-4],ErrorText3
	jz MAINERROR
	mov [filesize],eax

	cmp eax,_exe_P6_1_1_Size
		jz _exe_P6_1_1
	cmp eax,_exe_P5_1_1_Size
		jz _exe_P5_1_1
	cmp eax,_exe_K6_1_1_Size
		jz _exe_K6_1_1
	cmp eax,_exe_P5_Demo_Size
		jz _exe_P5_Demo
	mov DWORD [esp-4],ErrorText5
	jmp MAINERROR

_exe_P6_1_1:
	mov [BaseData],P6_struc
	jmp DETECT_EXE_SUCCESS
_exe_P5_1_1:
	mov [BaseData],P5_struc
	jmp DETECT_EXE_SUCCESS
_exe_K6_1_1:
	mov [BaseData],K6_struc
	jmp DETECT_EXE_SUCCESS
_exe_P5_Demo:
	mov [BaseData],Demo_Struc
DETECT_EXE_SUCCESS:
mov esi,[BaseData]

;=================================================================
mov eax,[entrypoint]
sub eax,00400000h
invoke SetFilePointer,[filehandle],eax,0,FILE_BEGIN

invoke WriteFile,[filehandle],[entry_call],5,byteswritten,0
	test eax,eax
	mov DWORD [esp-4],ErrorText4
	jz MAINERROR
	cmp [byteswritten],5
	jnz MAINERROR

mov eax,[exit_addr_1]
sub eax,00400000h
invoke SetFilePointer,[filehandle],eax,0,FILE_BEGIN

invoke WriteFile,[filehandle],[exit_call],6,byteswritten,0
	test eax,eax
	mov DWORD [esp-4],ErrorText4
	jz MAINERROR
	cmp [byteswritten],6
	jnz MAINERROR

mov eax,[exit_addr_2]
sub eax,00400000h
invoke SetFilePointer,[filehandle],eax,0,FILE_BEGIN

invoke WriteFile,[filehandle],[exit_call],6,byteswritten,0
	test eax,eax
	mov DWORD [esp-4],ErrorText4
	jz MAINERROR
	cmp [byteswritten],6
	jnz MAINERROR

mov eax,[freespace_addr]
sub eax,00400000h
invoke SetFilePointer,[filehandle],eax,0,FILE_BEGIN

invoke WriteFile,[filehandle],[maincode_addr],[maincode_length],byteswritten,0
	test eax,eax
	mov DWORD [esp-4],ErrorText4
	jz MAINERROR

;=================================================================
MAINEXIT:
	pop esi
	pop ebp
	pop edi
	pop ebx
	invoke CloseHandle,[filehandle]
		push WriteSuccess
		call DisplayMessage
	mov edi,SourceFile
	xor al,al
	or ecx,0FFFFFFFFh
	repnz scasb
	mov WORD [edi],0A0Dh
	mov eax,edi
	add eax,2
	sub eax,ATXFileNameStart
	mov [finalnamesize],al
		push finalnamesize
		call DisplayMessage
	invoke ExitProcess,0

;----------------
MAINERROR:
	sub esp,4		;last error at [esp-4]
	call DisplayMessage
	push _discard
	call DisplayMessage
	pop esi
	pop ebp
	pop edi
	pop ebx
		cmp [filehandle],0
		jz NoCloseHandle1
		invoke CloseHandle,[filehandle]
		NoCloseHandle1:
	invoke ExitProcess,-1

;=================================================================
DisplayMessage:
push STD_OUTPUT_HANDLE
call [GetStdHandle]
mov ecx,[esp+4]

sub esp,4
mov edx,esp
push 0
push edx
xor edx,edx
mov dl,[ecx]
add ecx,1
push edx
push ecx
push eax
call [WriteFile]
pop eax
ret 4

;=================================================================
section '.data' data readable writeable
;=================================================================
CommandLine		dd	0
hInstance		dd	0
filehandle		dd	0
filesize		dd	0
byteswritten		dd	0

finalnamesize		db	0
ATXFileNameStart	db	'ATX_'
SourceFile:
times 500		db	0

WriteSuccess	db	(ErrorText1-$-1),0Dh,0Ah,\
	"Executable successfully copied and patched as:",\
	 0Dh,0Ah
ErrorText1	db	(ErrorText2-$-1),0Dh,0Ah,\
	"Could not copy specified file. It may not exist, or no parameter;",\
	 0Dh,0Ah
ErrorText2	db	(ErrorText3-$-1),0Dh,0Ah,\
	"New file could not be opened for writing;",\
	 0Dh,0Ah
ErrorText3	db	(ErrorText4-$-1),0Dh,0Ah,\
	"Could not get file size;",\
	 0Dh,0Ah
ErrorText4	db	(ErrorText5-$-1),0Dh,0Ah,\
	"Could not write to copy of specified file;",\
	 0Dh,0Ah
ErrorText5	db	(End_ErrorTexts-$-1),0Dh,0Ah,\
	"Unsupported Trespasser executable;", \
	 0Dh,0Ah
End_ErrorTexts:

_discard	db	(end_discard-$-1),\
	"Please discard new file (if created).", \
	 0Dh,0Ah
end_discard:

;=================================================================
section '.exedata' data readable writeable
;=================================================================
BaseData	dd	0
include 'ATX_EXE_CODE.inc'
;---------------------------------------
P6_struc:
	dd 00637567h
	dd P6_maincode2
	dd 00609122h
	dd P6_1_1_JUMP
	dd P6_1_1_UNLOAD_CALL
	dd 0040DAEFh
	dd 0040E461h
	dd (ENDP6MAIN-P6_maincode)	;(same for all)

P5_struc:
	dd 0063A096h
	dd P5_maincode2
	dd 0060B9B2h
	dd P5_1_1_JUMP
	dd P5_1_1_UNLOAD_CALL
	dd 0040DAA3h
	dd 0040E411h
	dd (ENDP5MAIN-P5_maincode)
K6_struc:
	dd 00605986h
	dd K6_maincode2
	dd 005D7262h
	dd K6_1_1_JUMP
	dd K6_1_1_UNLOAD_CALL
	dd 0040D993h
	dd 0040E301h
	dd (ENDK6MAIN-K6_maincode)
Demo_Struc:
	dd 0063EC56h
	dd Demo_maincode2
	dd 0060C3D2h
	dd DEMO_JUMP
	dd DEMO_UNLOAD_CALL
	dd 0040DA83h
	dd 0040E141h
	dd (END_DEMOMAINCODE-Demo_maincode)
;---------------------------------------

P6_1_1_UNLOAD_CALL:
	call DWORD [Unload_P6_1_1]

P5_1_1_UNLOAD_CALL:
	call DWORD [Unload_P5_1_1]

K6_1_1_UNLOAD_CALL:
	call DWORD [Unload_K6_1_1]

DEMO_UNLOAD_CALL:
	call DWORD [Unload_DEMO]
;---------------------------------------
;=================================================================
section '.exedat2' data readable writeable
;=================================================================
P6_1_1_JUMP:
	org 00609122h
	call 00637567h
;=================================================================
section '.exedat3' data readable writeable
;=================================================================
P5_1_1_JUMP:
	org 0060B9B2h
	call 0063A096h
;=================================================================
section '.exedaa4' data readable writeable
;=================================================================
K6_1_1_JUMP:
	org 005D7262h
	call 00605986h
;=================================================================
section '.exedat5' data readable writeable
;=================================================================
DEMO_JUMP:
	org 0060C3D2h
	call 0063EC56h
;---------------------------------------
;=================================================================
section '.exedat6' data readable writeable
;=================================================================
P6_maincode2:
org 00637567h
	P6_maincode:
MAIN_CODE 00642148h,00642118h,00642120h,006423B4h,\
		006420D4h,Unload_P6_1_1
	ENDP6MAIN:
;=================================================================
section '.exedat7' data readable writeable
;=================================================================
P5_maincode2:
org 0063A096h
	P5_maincode:
MAIN_CODE 00648148h,00648118h,00648120h,006483B4h,\
		006480D4h,Unload_P5_1_1
	ENDP5MAIN:
;=================================================================
section '.exedat8' data readable writeable
;=================================================================
K6_maincode2:
org 00605986h
	K6_maincode:
MAIN_CODE 00610148h,00610118h,00610120h,006103B4h,\
		006100D4h,Unload_K6_1_1
	ENDK6MAIN:
;=================================================================
section '.exedat9' data readable writeable
;=================================================================
Demo_maincode2:
org 0063EC56h
	Demo_maincode:
MAIN_CODE 0064C158h,0064C128h,0064C130h,0064C48Ch,\
		0064C0D8h,Unload_DEMO
	END_DEMOMAINCODE:

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,'KERNEL32.DLL'

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 GetCommandLine,'GetCommandLineA',\
	 GetModuleHandle,'GetModuleHandleA',\
	 GetStdHandle,'GetStdHandle',\
	 SetFilePointer,'SetFilePointer',\
	 WriteFile,'WriteFile'

;=================================================================